//+------------------------------------------------------------------+
//|                                                Ema5cross2WMA.mq4 |
//|                                                     TradingForex |
//|                                              www.tradingforex.it |
//| Il presente Expert Advisor viene fornito da TradingForex.it      |
//| per ragioni didattiche e non rappresenta incitamento all'utilizzo|
//| nel trading reale ... Lo staff di TradingForex.it declina ogni   |
//| responsabilità per eventuali profitti/perdite di capitali        |
//| derivanti dal suo utilizzo ...                                   |
//+------------------------------------------------------------------+
#property copyright "Staff del Forum di TradingForex idea di Flavio Miccoli"
#property link      "www.tradingforex.it"

//Definizione costanti
#define LONG  1
#define SHORT 2
#define FLAT 3
#define neutro 1
#define acquisto 2
#define vendita 3


//variabili esterne
extern double lotti = 1.0;
extern int TimeFrame = PERIOD_M5;
extern double StopLoss = 15;
extern double TakeProfit = 5;

int start()// Corpo dell'expert advisor
  {
      if(VerificaSegnale()==neutro) return(0);
      if(VerificaSegnale()==acquisto)
      {
         if(VerificaPosizione()==FLAT)
         {
            compra();
            return(0);
         }
         if(VerificaPosizione()==SHORT)
         {
            chiudiPosizione();
            compra();
            return(0);
         }
         if(VerificaPosizione()==LONG) return(0);
      }
      if(VerificaSegnale()==vendita)
      {
         if(VerificaPosizione()==FLAT)
         {
            vendi();
            return(0);
         }
         if(VerificaPosizione()==LONG)
         {
            chiudiPosizione();
            vendi();
            return(0);
         }
         if(VerificaPosizione()==SHORT) return(0);
      }
      return(0);
  }
// inizio funzione di verifica segnale
int VerificaSegnale()
{  //Dichiarazione variabili 
   double EMA5Precedente  = iMA(0, TimeFrame, 5, 0, MODE_EMA, PRICE_CLOSE, 1);
   double WMA75Precedente = iMA(0, TimeFrame, 75, 0, MODE_LWMA, PRICE_CLOSE, 1);
   double WMA85Precedente = iMA(0, TimeFrame, 85, 0, MODE_LWMA, PRICE_CLOSE, 1);
   
   double EMA5Attuale  = iMA(0, TimeFrame, 5, 0, MODE_EMA, PRICE_CLOSE, 0);
   double WMA75Attuale = iMA(0, TimeFrame, 75, 0, MODE_LWMA, PRICE_CLOSE, 0);
   double WMA85Attuale = iMA(0, TimeFrame, 85, 0, MODE_LWMA, PRICE_CLOSE, 0);  
 // Segnale LONG
   if (EMA5Precedente < WMA75Precedente || EMA5Precedente < WMA85Precedente)
   {
      if (EMA5Attuale > WMA75Attuale && EMA5Attuale > WMA85Attuale)
      {
         return(acquisto);
      }
   }

//Fine Segnale LONG
//Segnale Short
if (EMA5Precedente > WMA75Precedente || EMA5Precedente > WMA85Precedente)
   {
      if (EMA5Attuale < WMA75Attuale && EMA5Attuale < WMA85Attuale)
      {
         return(vendita);
      }
   }
//Fine Segnale SHORT

//Segnale Neutro   
    return(neutro);
//Fine Segnale Neutro
}
//Fine funzione di verifica segnale

//Inizio verifica di posizioni aperte
int VerificaPosizione()
{
   bool orderExist = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
   if(!orderExist) return (FLAT);
   if(OrderSymbol()== Symbol()&&OrderMagicNumber()==101)
   {
      if(OrderType()==OP_BUY)
      return (LONG);
      else return (SHORT);
   }
   else return(FLAT);
}

int compra()
{
  int ticket=OrderSend(Symbol(),OP_BUY,lotti,Ask,0,Bid-StopLoss*Point,Bid+TakeProfit*Point,"E' stata aperta una posizione long",101,0,Green);
  if(ticket<0)
    {
     Print("Errore nella elaborazione ordine #",GetLastError());
     return(0);
    }
}

int vendi()
{
  int ticket=OrderSend(Symbol(),OP_SELL,lotti,Bid,0,Ask-StopLoss*Point,Ask+TakeProfit*Point,"E' stata aperta una posizione short",101,0,Red);
  if(ticket<0)
    {
     Print("Errore nella elaborazione ordine #",GetLastError());
     return(0);
    }
}

//chiude tutte le posizioni aperte relative al cross in oggetto generate da questo trading system
void chiudiPosizione()
{
   int total=OrdersTotal();
   for(int pos=0;pos<total;pos++)
    {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false)continue;
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==101)
      {
         if(OrderType()==OP_BUY)
         {
            OrderClose(OrderTicket(),OrderLots(),Bid,0,Orange);
         }
         if(OrderType()==OP_SELL)
         {
            OrderClose(OrderTicket(),OrderLots(),Ask,0,Orange);
         }
      }
    }
}